import sys
import urllib
import webbrowser

services = [
    # Web services
    ('s', 'safari-http://stackoverflow.com/search?q=%s'),
    ('w', 'safari-https://en.wikipedia.org/w/index.php?search=%s'),
    ('mac', 'safari-https://www.macupdate.com/find/mac/%s'),
    ('app', 'safari-http://appshopper.com/search/?search=%s'),
    ('imdb', 'safari-http://www.imdb.com/find?q=%s&s=all'),
    ('amaz', 'safari-http://www.amazon.com/s/ref=nb_sb_noss?url=search-alias%3Daps&field-keywords=%s'),
    ('wolf', 'safari-http://www.wolframalpha.com/input/?i=%s'),
    ('red', 'safari-http://www.reddit.com/r/search/search?q=%s'),
    ('to', 'safari-http://alternativeto.net/SearchResult.aspx?search=%s'),
    ('hack', 'safari-https://www.hnsearch.com/search#request/all&q=%s&start=0'),
    ('def', 'safari-http://www.merriam-webster.com/dictionary/%s'),

    # Apps
    ('op', 'onepassword://search/%s'),
    ('wiki', 'wikipanion:///%s'),
    ('tb', 'tweetbot:///search?query=%s'),
    ('te', 'terminology://x-callback-url/lookup?text=%s'),
    ('movie', 'imdb:///find?q=%s'),
    ('art', 'x-articles://?search=%s'),
    ('twi', 'twitterrific:///search?q=%s'),
    ('rd', 'rdio://search/%s'),
    ('day', 'fantastical://search?query=%s'),
    ('due', 'due://x-callback-url/search?query=%s'),
    ('wol', 'wolframalpha:///?i=%s'),
    ('store', 'http://phobos.apple.com/WebObjects/MZSearch.woa/wa/search?media=software&term=%s'),
]

query = sys.argv[1]
for shortcut, searchurl in services:
    service_identifier = '!%s ' % shortcut
    if not query.startswith(service_identifier):
        continue
    query = query[len(service_identifier):]
    break
else:
    searchurl = 'safari-https://duckduckgo.com/?q=%s'

webbrowser.open(searchurl % urllib.quote(query))